/**
 * Manually update matrix
 * @moduleName ManualUpdate
 * @snippet ManualUpdate|Constructor
ManualUpdate({})
 */
bento.define('components/manualupdate', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        var entity;
        var component = new Object({
            name: 'manualUpdate',
            start: function (data) {
                entity.object3D.matrixAutoUpdate = false;
                entity.object3D.updateMatrix();
            },
            attached: function (data) {
                entity = data.entity;
            }
        });
        return component;
    };
});