/**
 * Module description
 * @moduleName ConfettiString
 * @snippet ConfettiString|snippet
ConfettiString({
    position: new Vector2(0, 0),
    velocity: new Vector2(0, 0),
    friction: 0.95
})
 */
bento.define('entities/effects/confettistring', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/utils',
    'bento/tween',
    'globals',
    'color'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    Globals,
    Color
) {
    'use strict';
    // var trail = function (settings) {
    //     // --- Parameters ---
    //     var positionOffset = settings.positionOffset;
    //     var rotationOffset = settings.rotationOffset;
    //     var nodeLength = settings.nodeLength || 20;
    //     var nodeModulo = settings.nodeModulo || 5;
    //     var width = settings.width || 1;
    //     var material = settings.material || new THREE.MeshLambertMaterial({
    //         color: 0xffffff,
    //         transparent: true,
    //         opacity: 0.5,
    //         side: THREE.DoubleSide,
    //         blending: THREE.NormalBlending
    //     });
    //     // --- Variables ---
    //     var entity;
    //     var geometry;
    //     var mesh;
    //     // --- Functions ---
    //     var getLocalVector = function (thisVector) {
    //         var vec = thisVector.applyQuaternion(entity.quaternion);
    //         if (trail.rotationOffset) {
    //             vec.applyQuaternion(trail.rotationOffset);
    //         }
    //         return vec;
    //     };
    //     var setup = function () {
    //         var pos = entity.position.clone();
    //         if (trail.positionOffset) {
    //             pos.add(trail.positionOffset);
    //         }
    //         // trail geometry
    //         geometry = new THREE.Geometry();
    //         addFaces(pos);
    //         addFaces(pos);
    //         // make a mesh for this geo
    //         mesh = new THREE.Mesh(geometry, material);
    //         mesh.renderOrder = 1;
    //         geometry.boundingSphere = new THREE.Sphere(new THREE.Vector3(0, 0, 0), Infinity);
    //     };
    //     var cleanup = function () {
    //         //clean up
    //         if (geometry) {
    //             geometry.dispose();
    //         }
    //     };
    //     var addFaces = function (p) {
    //         var oldA;
    //         var oldB;
    //         if (geometry.vertices.length > 1) {
    //             oldA = geometry.vertices.length - 1;
    //             oldB = geometry.vertices.length - 2;
    //         }
    //         geometry.vertices.push(
    //             p.clone().add(getLocalVector(new THREE.Vector3(-trail.width * 0.5, 0, 0))),
    //             p.clone().add(getLocalVector(new THREE.Vector3(trail.width * 0.5, 0, 0)))
    //         );
    //         var newA = geometry.vertices.length - 1;
    //         var newB = geometry.vertices.length - 2;
    //         if (oldA !== undefined && oldB !== undefined) {
    //             geometry.faces.push(new THREE.Face3(newA, oldA, oldB));
    //             geometry.faces.push(new THREE.Face3(newA, oldB, newB));
    //         }
    //         // make the correct length
    //         if (geometry.faces.length > trail.nodeLength) {
    //             geometry.vertices.shift();
    //             geometry.vertices.shift();
    //             geometry.faces.pop();
    //             geometry.faces.pop();
    //         }
    //     };
    //     var updateFaceUVs = function (p) {
    //         //edit UVs
    //         var sizeY = (1 / trail.nodeLength);
    //         var sub_i = 1 - ((entity.ticker % trail.nodeModulo) / trail.nodeModulo);
    //         geometry.faceVertexUvs[0] = [];
    //         for (var i = 0; i < nodeLength; i++) {
    //             var ind = i + sub_i;
    //             var newY = ((ind + 1) * sizeY) * 2;
    //             var oldY = (ind * sizeY) * 2;
    //             geometry.faceVertexUvs[0].push([
    //                 new THREE.Vector2(0, 1 - newY),
    //                 new THREE.Vector2(0, 1 - oldY),
    //                 new THREE.Vector2(1, 1 - oldY)
    //             ]);
    //             geometry.faceVertexUvs[0].push([
    //                 new THREE.Vector2(0, 1 - newY),
    //                 new THREE.Vector2(1, 1 - oldY),
    //                 new THREE.Vector2(1, 1 - newY)
    //             ]);
    //         }
    //         geometry.uvsNeedUpdate = true;
    //     };
    //     var updateLastVerts = function (p) {
    //         if (geometry.vertices.length > 1) {
    //             geometry.vertices[geometry.vertices.length - 1] = p.clone().add(getLocalVector(new THREE.Vector3(trail.width * 0.5, 0, 0)));
    //             geometry.vertices[geometry.vertices.length - 2] = p.clone().add(getLocalVector(new THREE.Vector3(-trail.width * 0.5, 0, 0)));
    //             geometry.elementsNeedUpdate = true;
    //         }
    //     };
    //     var trail = {
    //         name: 'trail',
    //         positionOffset: positionOffset,
    //         rotationOffset: rotationOffset,
    //         nodeLength: nodeLength,
    //         width: width,
    //         nodeModulo: nodeModulo,
    //         start: function (data) {
    //             if (!entity) {
    //                 return;
    //             }
    //         },
    //         destroy: function (data) {
    //             cleanup();
    //         },
    //         update: function (data) {
    //             if (!entity) {
    //                 return;
    //             }
    //             var pos = entity.position.clone();
    //             if (trail.positionOffset) {
    //                 pos.add(trail.positionOffset);
    //             }
    //             if (entity.ticker % trail.nodeModulo === 0) {
    //                 addFaces(pos);
    //                 geometry.elementsNeedUpdate = true;
    //             } else {
    //                 updateLastVerts(pos);
    //             }
    //             updateFaceUVs(pos);
    //         },
    //         attached: function (data) {
    //             entity = data.entity;
    //             setup();
    //         }
    //     };
    //     return trail;
    // };

    return function (settings) {
        // --- VARS ---
        var isRemoving = false;
        var pointArray = [];
        var pointTimes = [];
        var viewport = Bento.getViewport();

        // --- PARAMETERS ---
        var position = settings.position || new Vector2(0, 0);
        var velocity = settings.velocity || new Vector2(0, 0);
        var friction = settings.friction || 1;
        var life = settings.life || Utils.getRandomRangeFloat(50, 70);
        var maxLife = life;
        var radius = settings.radius || 3;
        var color = settings.color || Utils.pickRandomFrom([new Color(255, 59, 59), new Color(255, 224, 111), new Color(59, 212, 255)]);
        var spinRate = Utils.getRandomRangeFloat(-0.1, 0.1);

        var line = new window.MeshLine();
        var material = new window.MeshLineMaterial({
            color: new THREE.Color(color.toInt()),
            resolution: new THREE.Vector2(viewport.width, viewport.height)
        });
        var lineMesh = new THREE.Mesh(line, material);
        
        var object3D = new THREE.Object3D().add(lineMesh);

        // --- COMPONENTS ---
        var behavior = {
            name: 'behaviorComponent',
            update: function (data) {

                if (!isRemoving) {
                    life -= data.speed;
                    if (life <= 0) {
                        isRemoving = true;
                        new Tween({
                            from: radius,
                            to: 0,
                            in: 15,
                            onUpdate: function (v, t) {
                                radius = v;
                            },
                            onComplete: function () {
                                entity.removeSelf();
                            }
                        });
                    }
                }

                // move
                //velocity.y += gravity * data.speed;
                entity.position.addTo(velocity.scalarMultiply(data.speed));
                velocity.scalarMultiplyWith(1 - ((1 - friction) * data.speed));
                velocity = velocity.rotateRadian(spinRate * (life / maxLife));
                line.setVertices(pointArray, function (p) {
                    return Math.min((p * pointArray.length / 30) * radius, radius);
                });
            },
            start: function (data) {
                data.renderer.three.scene.add(object3D);
            },
            destroy: function (data) {
                data.renderer.three.scene.remove(object3D);
                material.dispose();
                line.dispose();
            },
            draw: function (data) {
                var renderer = data.renderer;
                lineMesh.position.x = -entity.position.x;
                lineMesh.position.y = entity.position.y;
                renderer.render(object3D, material);
            }
        };

        // --- ENTITY ---
        var entity = new Entity({
            z: settings.z || 0,
            name: 'confettiString',
            family: ['effects'],
            position: position.clone(),
            float: false,
            updateWhenPaused: settings.updateWhenPaused,
            components: [
                behavior
            ]
        });
        Bento.objects.attach(entity);
        return entity;
    };
});