/**
 * Entity that lights up the UI layer
 * @moduleName UiLight
 * @snippet UiLight|Constructor
UiLight({})
 */
bento.define('entities/uilight', [
    'bento',
    'bento/utils',
    'bento/entity',
    'bento/components/sprite'
], function (
    Bento,
    Utils,
    Entity,
    Sprite
) {
    'use strict';
    var UiLight = function (settings) {
        var viewport = Bento.getViewport();
        var directionalLight = new THREE.DirectionalLight(0xffffff, 0.5);

        var ambientLight = new THREE.AmbientLight(0xffffff, 0.7);
        var behavior = new Object({
            name: 'behavior',
            start: function (data) {
                // guessed these values??
                directionalLight.target.x = viewport.width / 2;
                directionalLight.target.y = viewport.height / 2;
                directionalLight.position.x = viewport.width / 2 + 640;
                directionalLight.position.y = viewport.height / 2 + 640;
                directionalLight.position.z = 1000;
                spriteContainer.object3D.add(directionalLight);
                spriteContainer.object3D.add(ambientLight);
            },
            destroy: function (data) {
                spriteContainer.object3D.remove(ambientLight);
                spriteContainer.object3D.remove(directionalLight);
            }
        });
        var spriteContainer = new Sprite({
            imageName: 'gui/empty'
        });
        var entity = new Entity({
            z: 0,
            name: 'uiLight',
            components: [
                spriteContainer,
                behavior
            ]
        });
        return entity;
    };
    return UiLight;
});