/**
 * Global values
 * @moduleName Globals
 */
bento.define('globals', [
    'bento',
    'bento/utils',
    'managers/savevalues',
    'components/materialswapper',
    'onigiri/onigiri'
], function (
    Bento,
    Utils,
    SaveValues,
    MaterialSwapper,
    Onigiri
) {
    'use strict';
    var Globals = {
        puzzles: [ // note: I put this on line 20 so that the lineNumer-20 corresponds with the level
            'level-1',
            'level-2',
            'level-3',
            'level-4',
            'level-5b',
            'level-5ab',
            'level-5c',
            'level-6',
            'level-7',
            'pause-tutorial',
            'level-8',
            'level-9',
            'level-36',
            'level-10',
            'level-11',
            'level-12',
            'level-13',
            'level-14',
            'level-15',
            'level-16c',
            'level-17-2p',
            'level-18',
            'level-18a',
            'level-19',
            'level-20',
            'level-25',
            'level-21',
            'level-22',
            'level-23',
            'level-24',
            'level-25',
            'level-26',
            'level-27',
            'level-28',
            'level-29',
            'level-30',
            'level-31',
            'level-32',
            'level-33',
            'level-34',
            'level-35',
            'level-16d',
            'level-16a',
            'maarten-1',
            'maarten-2',
            'maarten-3',
            'maarten-4',
            'maarten-5',
            'maarten-6',
            'maarten-7',
            'maarten-8',
            'maarten-9',
            'maarten-10',
            'maarten-11',
            'maarten-12',
            'maarten-13',
            'maarten-14',
            'maarten-15',
            'maarten-16',
            'maarten-17',
            'maarten-18',
            'maarten-19',
            'maarten-20',
            'maarten-21',
            'maarten-22',
            'maarten-23',
            'maarten-24',
            'maarten-25',
            'maarten-26',
            'maarten-27',
            'maarten-28',
            'maarten-29',
            'maarten-30',
            'maarten-31',
            'maarten-32',
            'maarten-33',
            'maarten-34',
            'maarten-35',
            'manou-1',
            'manou-2',
            'manou-3',
            'manou-4',
            'manou-8',
            'manou-10',
            'manou-15',
            'rik-1',
            'maarten-72',
            'maarten-61',
            'rik-2',
            'maarten-64',
            'maarten-73',
            'maarten-74',
            'maarten-66',
            'maarten-67',
            'rik-3',
            'rik-13',
            'rik-5',
            'rik-6',
            'maarten-68',
            'maarten-69',
            'rik-10',
            'maarten-70',
            'maarten-71',
            'maarten-path-1',
            'maarten-path-3',
            'rik-7',
            'rik-14',
            'rik-8',
            'maarten-path-4',
            'maarten-path-2',
            'maarten-path-6',
            'rik-15',
            'rik-9',
            'rik-11',
            'rik-12',
            'rik-16',
            'rik-17',
            'rik-18',
            'rik-19',
            'rik-20',
            'maarten-path-7',
            'maarten-path-9',
            'maarten-75',
            'maarten-62',
            'maarten-57',
            'maarten-63',
            'rik-10',
            'rik-4',
            'rik-9',
            'maarten-path-10',
            'maarten-path-5',
            'maarten-76',
            'maarten-60',
            'maarten-58',
            'maarten-59',
            'maarten-path-8'
        ],
        bonusLevels: [
            'maarten_bonus-1',
            'maarten_bonus-2',
            'maarten_bonus-3',
            'maarten_bonus-4',
            'maarten_bonus-5',
            'maarten_bonus-6',
            'maarten_bonus-7',
            'maarten_bonus-8',
            'maarten_bonus-9',
            'maarten_bonus-10',
        ],
        /* @snippet Globals.puzzles|Array */
        /* @snippet Globals.wallFriction|Number */
        wallFriction: 0.75,
        /* @snippet Globals.wallRestitution|Number */
        wallRestitution: 0.1,
        currentPuzzle: '',

        /* @snippet Globals.balls|ArrayOfStrings */
        balls: [
            'default',
            'americanfootball',
            'eggplant',
            'bowlingball',
            'balloon',
            'bomb',
            'tennisball',
            'peach',
            'planet',
            'nerdemoji',
            'golf',
            'soccer',
            // 2nd page:
            'acorn',
            'apple',
            'corona',
            'easteregg',
            'raddish',
            'skull',
            'spike',
            'turnip',
            'volleyball-white',
            'volleyball',
            'watermellon',
            'yarn',
        ],
        /* @snippet Globals.players|ArrayOfStrings */
        players: [
            'default',
            'girl',
            'bear',
            'astronaut',
            'cowboy',
            'dino',
            'eagle',
            'fancy',
            'robot',
            // 2nd page:
            'americanfootballer',
            'bunny',
            'doctor',
            'frog',
            'gizmo',
            'kungfu',
            'monstervolleyballer',
            'skelly',
            'tomato',
        ],
        switchEvery: 5,
        backgrounds: [
            'bg',
            'bg-hills',
            'bg-bright',
            'bg-city',
            'bg-scifi',
            'bg-trees',
            'bg-beach',
            'bg-desert',
            'bg-egypt',
        ],
        wallColors: [
            '#FDE38F',
            '#FDA31F',
            '#FF7060',
            '#BFA0FF',
            '#44FFFF',
            '#A070F0',
            '#2560bf',
            '#dff0f1',
            '#c764bd',
            '#a76451',
            '#4fa435',
            '#788d8f',
        ],
        /* @snippet Globals.bonusFrequency|Number */
        // every X level that bonus level appears (note: also change SaveValues if needed)
        bonusFrequency: 5,

        getProgressionAmount: function () {
            var amount = 0.08;
            switch (SaveValues.unlockedPlayers.length) {
            case 1:
                amount = 0.35;
                break;
            case 2:
                amount = 0.30;
                break;
            case 3:
                amount = 0.25;
                break;
            case 3:
                amount = 0.20;
                break;
            default:
                amount = Utils.clamp(0.08, 0.17 - 0.02 * (SaveValues.unlockedPlayers.length - 3), 0.15);
                break;
            }
            // Utils.clamp(0.08, 0.17 - 0.02 * SaveValues.unlockedPlayers.length, 0.15);
            return amount;
        },

        // example of layer definitions
        Layers: {
            BACKGROUND: 0,
            /* @snippet Globals.Layers.GUI|100 */
            GUI: 100,
            /* @snippet Globals.Layers.POPUPS|200 */
            POPUPS: 200,
            /* @snippet Globals.Layers.COINS|300 */
            COINS: 300,
            /* @snippet Globals.Layers.FADE|400 */
            FADE: 400,
            /* @snippet Globals.Layers.IAP|500 */
            IAP: 500,
            IPHONE_X_OVERLAY: 1000
        },
        // example of pauselevel definitions
        PauseLevels: {
            NONE: 0,
            PAUSE: 1,
            SYSTEM: 2
        },
        Colors: {
            /* @snippet Globals.Colors.darkblue|#25308c */
            darkblue: '#25308c',
            /* @snippet Globals.Colors.lightblue|#25d7ff */
            lightblue: '#25d7ff',
            /* @snippet Globals.Colors.coin|#fedb10 */
            coin: '#fedb10',
            /* @snippet Globals.Colors.coinOutline|#ff5028 */
            coinOutline: '#ff5028',
        },

        // colors and backgrounds
        getBackground: function () {
            var imageName = Bento.saveState.load('cheat-background', 'default');
            var cycle = 0;

            // bonus
            if (SaveValues.levelsUntilBonus <= 0) {
                return 'bg-bonus2';
            }

            if (imageName !== 'Gradient...') {
                if (imageName === 'default') {
                    // cycle through the images
                    cycle = Math.floor(SaveValues.currentLevel / Globals.switchEvery) % Globals.backgrounds.length;
                    return Globals.backgrounds[cycle] || 'bg';
                }
                return imageName;
            }
        },
        getWallColor: function () {
            var cycle = 0;
            // bonus
            if (SaveValues.levelsUntilBonus <= 0) {
                return '#003a6f';
            }

            if (Bento.saveState.load('cheat-setWallColor', 'default') === 'default') {
                cycle = Math.floor(SaveValues.currentLevel / Globals.switchEvery) % Globals.wallColors.length;
                return Globals.wallColors[cycle] || '#fde38f';
            } else {
                return Bento.saveState.load('cheat-wallcolor', '#fde38f');
            }
        },
        getLineColor: function () {
            return '#b95b01';
        },
        getPlayerTexture: function (key) {
            var skin = Bento.saveState.load('cheat-playerskin', 'default');
            if (skin === 'default') {
                // return 'textures/player';
                return 'textures/players/tex-baller-' + (key || SaveValues.currentPlayer);
            } else {
                return 'textures/player-b';
            }
        },
        getEnemyTexture: function () {
            var skin = Bento.saveState.load('cheat-playerskin', 'default');
            if (skin === 'default') {
                return 'textures/guard';
            } else {
                return 'textures/guard-b';
            }
        },
        getPlayerMaterial: function (skin, mesh, solidColor) {
            return new MaterialSwapper({
                id: 'player-' + skin, // unique id for refcounting
                deepSwap: true,
                type: 'MeshStandardMaterial',
                mesh: mesh,
                materialSettings: {
                    color: solidColor ? 0x44aa00 : 0xffffff,
                    map: solidColor ? undefined : Onigiri.getTexture(Globals.getPlayerTexture(skin), {}),
                    skinning: true,
                    metalness: 0
                }
            });
        },

        paths: {}, // just adding this for clarity, level spawner replaces this every time anyway

        tapStyle: 'tapAndHold', // 'tap' or 'tapAndHold'

        // corrected angles:
        ballSettings: {
            'acorn': {
                eulerY: Math.PI / 2,
                eulerX: -Math.PI / 2                
            },
            'watermellon': {
                eulerY: Math.PI / 2,
                shininess: 0,
                reflectivity: 0
            },
            'turnip': {
                eulerY: Math.PI / 2,              
            },
            'raddish': {
                eulerY: Math.PI / 2,              
            },
            'skull': {
                eulerX: Math.PI / 8,
                eulerY: Math.PI,              
            },
            'apple': {
                eulerY: Math.PI / 2
            },
            'americanfootball': {
                fitBy: 'height'
            },
            'balloon': {
                eulerX: -Math.PI / 8,
                eulerY: Math.PI / 2
            },
            'bomb': {
                eulerX: -Math.PI / 8,
                eulerY: Math.PI / 2
            },
            'eggplant': {
                eulerY: Math.PI / 2
            },
            'easteregg': {
                eulerY: Math.PI / 2                
            },
            'laughcryemoji': {
                eulerX: Math.PI / 8,
                eulerY: Math.PI,
                fitBy: 'height'
            },
            'nerdemoji': {
                eulerX: Math.PI / 8,
                eulerY: Math.PI,
                fitBy: 'height'
            },
            'planet': {
                fitBy: 'height'
            },
            'peach': {
                eulerY: Math.PI / 2
            },
            'tennisball': {
                shininess: 0,
                reflectivity: 0
            },
            'yarn': {
                fitBy: 'depth'
            }
        },
        /* @snippet Globals.didGetKey|Boolean */
        didGetKey: false,
        /* @snippet Globals.coinsCollected|Number */
        coinsCollected: 0
    };

    /* @snippet Globals.lvPauseTutorial|Numver */
    Globals.lvPauseTutorial = Globals.puzzles.indexOf('pause-tutorial');

    return Globals;
});