/**
 * TEMP: just a pause button for now, specifically to catch the Android back button
 * @moduleName SettingsButton
 * @snippet SettingsButton|Constructor
SettingsButton({})
 */
bento.define('gui/buttons/settingsbutton', [
    'bento',
    'bento/utils',
    'bento/entity',
    'bento/math/vector2',
    'bento/math/rectangle',
    'globals',
    'gui/iconbutton',
    'gui/hdbuttonsprite',
    'gui/popups/settingspopup'
], function (
    Bento,
    Utils,
    Entity,
    Vector2,
    Rectangle,
    Globals,
    IconButton,
    HdButtonSprite,
    SettingsPopup
) {
    'use strict';
    var SettingsButton = function (settings) {
        var entity = new IconButton({
            z: Globals.Layers.POPUPS,
            name: 'settingsButton',
            sprite: HdButtonSprite({
                imageName: 'gui/buttons/settings',
                frameCountX: 1,
                frameCountY: 1,
                width: 32
            }),
            onClick: function () {
                Bento.objects.attach(new SettingsPopup({}));
            },
            components: [
                
            ].concat(settings.components || [])
        });
        return entity;
    };
    return SettingsButton;
});