/**
 * Show confetti on sides of screen
 * @moduleName Confetti
 * @snippet Confetti|constructor
Confetti({})
 */
bento.define('gui/widgets/confetti', [
    'bento',
    'bento/utils',
    'entities/effects/confettistring',
    'entities/effects/confettiburst',
    'globals',
    'bento/math/vector2'
], function (
    Bento,
    Utils,
    ConfettiString,
    ConfettiBurst,
    Globals,
    Vector2
) {
    'use strict';
    var Confetti = function (settings) {
        // left burst
        var viewport = Bento.getViewport();
        var z = settings.z;
        var life = settings.life || 1;
        Utils.repeat(20, function (i, l) {
            new ConfettiBurst({
                z: z,
                float: true,
                updateWhenPaused: Bento.objects.isPaused(),
                position: new Vector2(Utils.getRandomRangeFloat(-8, 8), viewport.height * 2 / 3 + Utils.getRandomRangeFloat(-4, 4)),
                velocity: new Vector2(Utils.getRandomRangeFloat(0, 4) * 2, Utils.getRandomRangeFloat(-12, 0) * 2),
                friction: 0.95,
                particleScale: 0.04 * 2 + Utils.getRandomFloat(0.03),
                life: Utils.getRandomRangeFloat(50, 70) * 3 * life,
            });
        });
        // Utils.repeat(Utils.isNativeAndroid() ? 6 : 10, function (i, l) {
        //     new ConfettiString({
        //         z: z,
        //         updateWhenPaused: Bento.objects.isPaused(),
        //         position: new Vector2(Utils.getRandomRangeFloat(-8, 8), viewport.height * 2 / 3 + Utils.getRandomRangeFloat(-4, 4)),
        //         velocity: new Vector2(Utils.getRandomRange(4, 8), 0).rotateDegree(Utils.getRandomRangeFloat(-90, -45)),
        //         friction: 0.95
        //     });
        // });
        // right burst
        Utils.repeat(10, function (i, l) {
            new ConfettiBurst({
                z: z,
                updateWhenPaused: Bento.objects.isPaused(),
                position: new Vector2(viewport.width + Utils.getRandomRangeFloat(-8, 8), viewport.height * 2 / 3 + Utils.getRandomRangeFloat(-4, 4)),
                velocity: new Vector2(Utils.getRandomRangeFloat(-4, 0) * 2, Utils.getRandomRangeFloat(-12, 0) * 2),
                friction: 0.95,
                particleScale: 0.04 * 2 + Utils.getRandomFloat(0.03),
                life: Utils.getRandomRangeFloat(50, 70) * 3 * life
            });
        });
        // Utils.repeat(Utils.isNativeAndroid() ? 6 : 10, function (i, l) {
        //     new ConfettiString({
        //         z: z,
        //         updateWhenPaused: Bento.objects.isPaused(),
        //         position: new Vector2(viewport.width + Utils.getRandomRangeFloat(-8, 8), viewport.height * 2 / 3 + Utils.getRandomRangeFloat(-4, 4)),
        //         velocity: new Vector2(Utils.getRandomRange(-8, -4), 0).rotateDegree(Utils.getRandomRangeFloat(45, 90)),
        //         friction: 0.95
        //     });
        // });
    };
    return Confetti;
});