/**
 * wrapper for banners
 * @moduleName BannerAd
 */
bento.define('modules/banner', [
    'bento',
    'bento/eventsystem',
    'modules/ironsource'
], function (
    Bento,
    EventSystem,
    IronSource
) {
    'use strict';
    /**
     * Main module
     */
    var BannerAd = {
        /**
         * @snippet BannerAd.showBanner|snippet
BannerAd.showBanner();
         */
        showBanner: function (settings) {
            var bannerStatus = IronSource.getBannerStatus();
            if (!settings || settings && !settings.noAds) {
                if (!bannerStatus.visible) {
                    IronSource.showBanner(function() {
                        EventSystem.fire('bannerStatusChanged', {});
                    });
                } else {
                    EventSystem.fire('bannerStatusChanged', {});
                }
            } else {
                if (bannerStatus.prepared) {
                    IronSource.removeBannerView(function () {
                        EventSystem.fire('bannerStatusChanged', {});
                    });
                }
            }
        },
        /**
         * @snippet BannerAd.isVisible|snippet
BannerAd.isVisible()
         */
        isVisible: function () {
            return IronSource.isBannerVisible();
        },
        /**
         * @snippet BannerAd.hideBanner|snippet
BannerAd.hideBanner();
         */
        hideBanner: function (settings) {
            var bannerStatus = IronSource.getBannerStatus();
            if (bannerStatus.visible) {
                IronSource.hideBanner(function () {
                    EventSystem.fire('bannerStatusChanged', {});
                });
            }
        },
        /**
         * @snippet BannerAd.removeBanner|snippet
BannerAd.removeBanner();
         */
        removeBanner: function (settings) {
            var bannerStatus = IronSource.getBannerStatus();
            if (bannerStatus.prepared) {
                IronSource.removeBannerView(function () {
                    EventSystem.fire('bannerStatusChanged', {});
                });
            }
        },
    };
    return BannerAd;
});